<app-page-title [heading]="heading" [subheading]="subheading" [icon]="icon">
    <button (click)="newRow(); openModalPlatillo(modalPlatillo)" class="btn btn-primary" [disabled]="loading">
        <i class="fas fa-plus mr-2"></i>Nuevo
    </button>
    <button (click)="printPDF()" class="btn btn-danger ml-1" [disabled]="dataGrid.data.length === 0 || loading">
        <i class="fas fa-file-pdf mr-2"></i>PDF
    </button>
</app-page-title>

<div class="card">
    <div class="card-body">

        <div class="animated fadeIn" *ngIf="!loading">
            <kendo-grid [kendoGridBinding]="dataGrid" [filterable]="true" [selectable]="true" [navigable]="true"
                [reorderable]="true" [resizable]="true" [sortable]="true" [pageSize]="pageSize" [skip]="skip"
                [pageable]="{buttonCount: 5, pageSizes: [10, 25, 50]}" style="height: 75vh;">
                <ng-template kendoGridToolbarTemplate>
                  <button type="button" kendoGridExcelCommand icon="file-excel" [disabled]="dataGrid.data.length === 0"
                   class="btn-success">Exportar Excel</button>
                </ng-template>
                <kendo-grid-column field="pdesc" title="Descripción" width="250"></kendo-grid-column>
                <kendo-grid-column field="tipo" title="Tipo" width="110" [filterable]="false" class="text-right">
                </kendo-grid-column>
                <kendo-grid-column field="platillo" title="Platillo" width="110" [filterable]="false"
                    class="text-right">
                </kendo-grid-column>
                <kendo-grid-column field="pprecio" title="Precio" width="150" [filterable]="false" class="text-right">
                    <ng-template kendoGridCellTemplate let-dataItem>{{ dataItem.pprecio | kendoNumber:'##.00' }}
                    </ng-template>
                </kendo-grid-column>
                <kendo-grid-column field="Inactivo" title="Inactivo" width="80" [filterable]="false">
                  <ng-template kendoGridCellTemplate let-dataItem>
                    {{dataItem.Inactivo ? 'Si' : 'No'}}
                  </ng-template>
                </kendo-grid-column>
                <kendo-grid-command-column title="Actions" width="280">
                    <ng-template kendoGridCellTemplate let-isNew="isNew" let-dataItem>
                        <button class="btn btn-shadow btn-light"
                            (click)="editRow(dataItem); openModalPlatillo(modalPlatillo);" [disabled]="loading">
                            <i class="fas mr-2 text-primary"
                                [ngClass]="{'fa-spinner fa-spin': loading, 'fa-edit': !loading }"></i>Editar
                        </button>
                        <button class="btn btn-shadow btn-light ml-1"
                            (click)="btnModificadores(dataItem); openModalPlatillo(modalModif);"
                            [disabled]="loading">Modificador
                        </button>
                        <button class="btn btn-shadow btn-light ml-1" (click)="deleteRow(dataItem)"
                            [disabled]="loading">
                            <i class="fas text-danger mr-2"
                                [ngClass]="{'fa-spinner fa-spin': loading, 'fa-trash': !loading }"></i>Eliminar
                        </button>
                    </ng-template>
                </kendo-grid-command-column>
                <kendo-grid-excel fileName="{{this.heading}}.xlsx" [fetchData]="allData"></kendo-grid-excel>
            </kendo-grid>
        </div>

        <app-loading *ngIf="loading"></app-loading>

    </div>
</div>

<ng-template #modalPlatillo let-c="close" let-d="dismiss">
    <form [formGroup]="myFormGroup" class="k-form">
        <div class="modal-header">
            <legend *ngIf="!flagEdit">Nuevo Platillo</legend>
            <legend *ngIf="flagEdit">Actualizar Platillo</legend>
            <button class="close" aria-label="Close" (click)="d()">
                <span aria-hidden="true">&times;</span>
            </button>
        </div>

        <div class="modal-body">
            <div class="row">
                <div class="col-5">
                    <div class="row">
                        <label class="k-form-field col-12">
                            <span>Tipo</span>
                            <kendo-combobox [data]="dsTipos" [textField]="'tdesc'" [valueField]="'tipo'"
                                formControlName="tipo" [valuePrimitive]="true" class="w-100">
                            </kendo-combobox>
                        </label>
                    </div>
                    <div class="row">
                        <label class="k-form-field col-4">
                            <span>Platillo</span>
                            <input type="number" class="k-textbox" formControlName="platillo"
                            [readOnly]="flagEdit" min="0" max="9999">
                        </label>
                        <label class="k-form-field col-8">
                            <span>Descripción</span>
                            <input class="k-textbox" formControlName="pdesc" maxlength="30">
                        </label>
                    </div>
                    <div class="row">
                        <label class="k-form-field col-6">
                            <span>Clasificación</span>
                            <kendo-combobox [data]="dsClasificacion" [textField]="'cdesc'" [valueField]="'clasif'"
                                formControlName="pclas" [valuePrimitive]="true" class="w-100">
                            </kendo-combobox>
                        </label>
                        <label class="k-form-field col-3">
                            <span>Impresora</span>
                            <input type="number" class="k-textbox" formControlName="nimp" min="0" max="9">
                        </label>
                        <label class="k-form-field col-3">
                            <span>Enviar</span>
                            <kendo-switch formControlName="Enviar" [onLabel]="'Si'" [offLabel]="'No'">
                            </kendo-switch>
                        </label>
                    </div>
                    <div class="row">
                        <label class="k-form-field col-4">
                            <span>Tiempo</span>
                            <input type="number" class="k-textbox" formControlName="Tiempo" min="0" max="9">
                        </label>

                        <label class="k-form-field col-4">
                            <span>Precio</span>
                            <input type="number" class="k-textbox" formControlName="pprecio" min="0" max="999999">
                        </label>
                        <label class="k-form-field col-4">
                            <span>Inactivo</span>
                            <kendo-switch formControlName="Inactivo" [onLabel]="'Si'" [offLabel]="'No'">
                            </kendo-switch>
                        </label>
                    </div>
                </div>
                <div class="row col-7">
                    <div class="col-6">
                        <label class="k-form-field">
                            <span>Código</span>
                            <kendo-combobox [data]="dsCodigos" [textField]="'cdesc'" [valueField]="'Codigo'"
                                [valuePrimitive]="true" formControlName="codigo" class="w-100">
                            </kendo-combobox>
                        </label>
                        <label class="k-form-field">
                            <span>U/M</span>
                            <kendo-combobox [data]="dsUnidadMedida" [textField]="'cDesc'" [valueField]="'cMedida'"
                                formControlName="Medida" [valuePrimitive]="true" class="w-100">
                            </kendo-combobox>
                        </label>
                        <label class="k-form-field">
                            <span>P.S. CFD</span>
                            <input class="k-textbox" name="platillo">
                        </label>
                    </div>
                    <div class="col-6">
                        <label class="k-form-field">
                            <span>Moneda</span>
                            <kendo-combobox [data]="dsMonedas" [textField]="'mdesc'" [valueField]="'Moneda'"
                                formControlName="Moneda" [valuePrimitive]="true" class="w-100">
                            </kendo-combobox>
                        </label>
                        <label class="k-form-field">
                            <span>Desglose</span>
                            <kendo-combobox [data]="dsDesglose" [textField]="'ddesc'" [valueField]="'dplat'"
                                formControlName="dplat" [valuePrimitive]="true" class="w-100">
                            </kendo-combobox>
                        </label>
                        <label class="k-form-field">
                            <span>Subtipo</span>
                            <kendo-combobox [data]="dsSubtipos" [textField]="'cDesc'" [valueField]="'iSubTipo'"
                                [valuePrimitive]="true" formControlName="iSubtipo" class="w-100">
                            </kendo-combobox>
                        </label>
                    </div>
                </div>
            </div>
        </div>
        <div class="modal-footer">
            <button class="btn btn-success mr-1" [disabled]="myFormGroup.invalid || loading"
                (click)="guardarForm(); c();">
                <i class="fas fa-save mr-2"></i>Guardar
            </button>
            <button class="btn btn-secondary" (click)="closeForm(); c();">Cerrar</button>
        </div>
    </form>
</ng-template>
<ng-template #modalModif let-c="close" let-d="dismiss">
    <div class="modal-header">
        <h6>Agregar Modificadores a Platillos</h6>
    </div>
    <div class="modal-body">
        <app-add-modificador [data]="platilloSelected"></app-add-modificador>
    </div>
    <div class="modal-footer">
        <button class="btn btn-secondary" (click)="c()">Cerrar</button>
    </div>
</ng-template>
